Skip to main content
Available in🇮🇳 India
You can integrate with Razorpay APIs to start accepting international card payments. Razorpay Chargeback Guarantee Program on international cards safeguards businesses from fraud chargeback. Businesses provide additional category-specific details to enhance our risk model’s ability to detect risky transactions. Razorpay uses this information to enhance risk assessment for international cards, aiming to achieve the highest success rate while minimising fraud.
Watch Out!
  • Category-specific risk rules will not be effective unless you provide additional details.
  • You must have a PCI compliance certificate to enable this feature on your account.

Integration Steps

Follow the steps given below to integrate S2S JSON API with browser flow and accept payments using cards. 1.1 Integrate Razorpay Shield JS
1.2 Create Order and Payment
1.3 Handle Payment Success and Error Events
1.4 Verify Payment Signature
1.5 Integrate Payments Rainy Day Kit
1.6 Verify Payment Status

1.1 Integrate Razorpay Shield JS

Integrate SHIELD JS and pass session_id in Create Order and Payment.

1.2 Create Order and Payment

This step demonstrates creating an Order and processing a Payment using Razorpay APIs. Depending on your integration type, you can choose between:
Create an order along with payment using the consolidated order and payment API. This single API call combines order and payment creation, resulting in a more efficient and faster transaction process.Create an order along with payment by:
  • Making a single API call to Razorpay, combining order and payment creation.
  • Authenticating using the provided credentials, ensuring access to the consolidated payment API.
  • Manually integrating the API sample codes on your server.
The following API will create an order along with payment with card as the payment method:POST /orders
integer
required
Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Watch Out!As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to charge a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as 99990 and not 99991.
string
required
The currency in which the transaction should be made. View the list of supported currencies. The length must be 3 characters.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
string
Your receipt id for this order should be passed here. Maximum length is 40 characters.
boolean
Indicates whether the customer can make a partial payment. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
object
required
Details about the customer/user.
string
required
The customer’s name. For example, Gaurav Kumar.
string
required
The customer’s phone number. A maximum length of 15 characters, including country code. For example, +919000090000.
string
required
The customer’s email address. For example, gaurav.kumar@example.com.
object
Additional details of the customer, including past transaction data.
integer
Total orders placed by the account so far on the merchant platform. For example, 22.
integer
Total chargeback received for the customer account on the merchant platform. For example, 4.
string
Your company’s passenger classification, such as with a frequent flyer program. In this case, you might use values such as:
  • standard
  • gold
  • platinum
string
To share if the user is an agent, corporate, or individual. Possible values:
  • agent
  • corporate
  • individual
boolean
To denote if the buyer is on guest checkout or has logged into the account. Possible values:
  • true: If the user is logged into the account.
  • false: If the user is on guest checkout.
integer
UNIX timestamp when the customer account was created with the merchant. For example, 1234567890.
object
required
This will have details about the billing address of the customer/user.
string
required
Address Line 1 of the address.
string
required
Address Line 2 of the address.
string
required
City of the address. For example, Bengaluru.
string
required
ISO3 country code of the billing address. For example, IND.
string
required
Name of the state. For example, KA.
string
required
Zipcode of the state. For example, 560001.
float
required
Latitude of the position expressed in decimal degrees (WSG 84), for example, 6.244203. A positive value denotes the northern hemisphere or the equator, and a negative value denotes the southern hemisphere. The number of digits represents the precision of the coordinate.
float
required
Longitude of the position expressed in decimal degrees (WSG 84), for example, -75.581211. A positive value denotes east longitude or the prime meridian, and a negative value denotes west longitude. The number of digits represents the precision of the coordinate.
integer
Total sum of the cart value.
object
required
Details about the specific items added to the cart.
string
required
Defines the category type. Possible values:
  • travel
  • hotel
  • e_commerce
  • digital_services
  • mutual_fund
string
required
unique product id defined by the business.
string
The name of the product.
string
Description of the product.
integer
required
Number of tickets/items/quantity to be purchased.
string
URL of the product image.
string
URL of the product’s listing page.
integer
required
Unit price of the product in paisa. (needs to be inclusive of tax)
integer
Offer price of the product. The offer price can be lower than the price if the business is running any discount on the product.
integer
Tax amount that needs to be added to the product. In case the offer_price is tax-inclusive, keep it blank.
object
Details about the type-specific data points. Will vary based on the type selected.
string
The sub-type of the line item. Possible values:
  • stay
  • breakfast
  • dinner
  • lunch
  • early_checkin
  • late_chechout
  • others
string
Represents an ISO 8601-encoded date string. For example, September 7, 2019 is represented as 2019-07-16.
string
Represents an ISO 8601-encoded date string. For example, September 7, 2019 is represented as 2019-07-16.
string
Represents the type of the property. Possible values:
  • resort
  • hostel
  • hotel
  • inn
  • lodge
  • motel
  • apartment
  • bed_and_breakfast
  • tent
  • villa
integer
Denotes the star rating of the property. Possible values: 1 to 7.
string
Brand name of the property. For example, Marriott Group.
object
Details of the property address.
string
Address Line 1 of the address.
string
Address Line 2 of the address.
string
city of the address. For example, Bengaluru.
string
ISO3 country code of the billing address. For example, IND.
string
Name of the state. For example, KA.
string
Zipcode of the state. For example, 560001.
float
Latitude of the position expressed in decimal degrees (WSG 84), for example, 6.244203. A positive value denotes the northern hemisphere or the equator, and a negative value denotes the southern hemisphere. The number of digits represents the precision of the coordinate.
float
Longitude of the position expressed in decimal degrees (WSG 84), for example, -75.581211. A positive value denotes east longitude or the prime meridian, and a negative value denotes west longitude. The number of digits represents the precision of the coordinate.
object
Details associated with passengers/travellers/beneficiaries.
string
Name of the passenger/traveler/beneficiary.
string
Email address of the passenger/traveler/beneficiary.
object
Details associated with passengers/travelers/beneficiaries.
integer
UNIX timestamp of the date of birth of the individual. For example, 1234567890.
string
Type of the flight ticket. Possible values:
  • Business
  • Suite
  • Premium
  • Deluxe
  • Standard
object
Identity details of the passenger/beneficiary.
string
National ID number. For example, Adhaar number for India.
string
Passport number of the individual.
array
Payment capture settings for the payment. The options sent here override the account level auto-capture settings configured using the Dashboard.
string
required
Option to automatically capture payment. Possible values:
  • automatic: Payments are auto-captured according to the configurations specified in the capture_options array.
  • manual: You have to manually capture payments using our Capture API or from the Dashboard.
array
Use this array to determine the expiry period for automatic and manual capture of payments and the refund speed in the case of non-capture.
integer
Time in minutes till when payments in the authorized state should be auto-captured. Minimum value 12 minutes. This parameter is mandatory only if the value of capture parameter is automatic.
integer
Time in minutes till when you can manually capture payments in the authorized state.
  • Must be equal to or greater than the automatic_expiry_period value.
  • Default value 7200 minutes.
  • Maximum value 7200 minutes.
  • Payments in the authorized state after the manual_expiry_period are auto-refunded.
string
required
Refund speed for payments that were not captured (automatically or manually). Possible values:
  • optimum: We try to process the refund instantly. We charge a small fee for this. If it is not possible to process an instant refund, we will process a normal refund in 5-7 working days. Learn more about instant refunds.
  • normal: The refund is processed in 5-7 working days.

    If no value is passed, the refund is processed using the default speed set on the Dashboard.
string
Denotes if the cart items are refundable or not. Possible values:
  • full
  • partial
  • not_allowed
object
Details of the campaign. *Can be extended to share UTM parameters.
string
Unique identifier of the campaign. For example, PQR12453.
string
Name of the campaign.
string
A human-readable description of the campaign.
string
The marketing channel used.
string
The referrer of the marketing event. Example values: google, newsletter.
string
The medium that the campaign is using. Example values: cpc, banner, etc.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
object
required
Details about the payment.
string
required
Phone number of the customer. The maximum length supported is 15 characters, inclusive of country code.
string
required
Email address of the customer. The maximum length supported is 40 characters.
string
URL endpoint where Razorpay will submit the final payment status.
string
required
Name of the payment method. Possible value is card.
object
required
Details associated with the card.
string
required
Unformatted card number.
string
required
Name of the cardholder.
integer
required
Expiry month for the card in MM format.
string
required
Expiry year for the card in YY format.
string
required
CVV printed on the back of the card.
Handy Tips
  • CVV is not required by default for tokenised cards across all networks.
  • CVV is optional for tokenised card payments. Do not pass dummy CVV values.
  • To implement this change, skip passing the cvv parameter entirely, or pass a null or empty value in the CVV field.
  • We recommend removing the CVV field from your checkout UI/UX for tokenised cards.
  • If CVV is still collected for tokenised cards and the customer enters a CVV, pass the entered CVV value to Razorpay.
object
This will have details about the billing address of the customer/user.
string
Address Line 1 of the address.
string
Address Line 2 of the address.
string
City of the address. For example, Bengaluru.
string
ISO3 country code of the billing address. For example, IND.
string
Name of the state. For example, KA.
string
Zipcode of the state. For example, 560001.
object
Details of the authentication channel.
string
The authentication channel for the payment. Possible values:
  • browser (default)
  • app
string
required
Details of the device fingerprint.
object
required
id of the checkout entity that is created.
object
required
Information regarding the customer’s browser. This parameter need not be passed when authentication_channel=app.
boolean
Indicates whether the customer’s browser supports Java. Obtained from the navigator HTML DOM object. Possible values:
  • true: Customer’s browser supports Java.
  • false: Customer’s browser does not support Java.
boolean
Indicates whether the customer’s browser can execute JavaScript. Obtained from the navigator HTML DOM object. Possible values:
  • true: Customer’s browser can execute JavaScript.
  • false: Customer’s browser cannot execute JavaScript.
integer
Time difference between UTC time and the cardholder’s browser local time. Obtained from the getTimezoneOffset() method applied to the Date object.
integer
Obtained from the payer’s browser using the screen.colorDepth HTML DOM property.
integer
Total width of the payer’s screen in pixels. Obtained from the screen.width HTML DOM property.
integer
Obtained from the navigator HTML DOM object.
string
Referrer header passed by the client’s browser.
string
required
The User-Agent header of the user’s browser. The default value will be passed by Razorpay if not provided by you.
string
required
The customer’s IP address.
integer
The transaction amount, expressed in the currency subunit. For example, for an actual amount of ₹299.35, the value of this field should be 29935.
integer
The amount pending against the order.
integer
The amount paid against the order.
integer
The number of payment attempts, successful and failed, that have been made against this order.
integer
The UNIX timestamp at which the order is created.
string
The currency in which the transaction should be made. View the list of supported currencies. Length must be of 3 characters.
string
Name of the entity. Here, it is order.
string
The unique identifier of the order.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
string
The unique identifier of the offer.
array
A list of action objects available to continue the payment process. Present when the payment requires further processing.
string
Indicates the next step to continue the payment process. Possible values:
  • otp_generate: Use this URL to allow the customer to generate OTP and complete the payment on your webpage.
  • redirect: Use this URL to redirect the customer to submit the OTP on the bank page.
string
URL to be used for the action indicated.
string
Unique identifier of the payment. Present for all responses.
string
Your receipt id for this order should be passed here. Maximum length is 40 characters.
string
The status of the order. Possible values:
  • created: When you create an order, it is in the created state. It stays in this state till a payment is attempted on it.
  • attempted: An order moves from created to attempted state when a payment is first attempted on it. It remains in the attempted state till one payment associated with that order is captured.
  • paid: After the successful capture of the payment, the order moves to the paid state. No further payment requests are permitted once the order moves to the paid state. The order stays in the paid state even if the payment associated with the order is refunded.
The error response parameters are available in the API Reference Guide.
If you are using separate APIs to create Order and process Payment, follow the steps given below:
Use the Orders API to create an order before initiating a payment.POST /orders
integer
required
Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Watch Out!As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to charge a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as 99990 and not 99991.
string
required
The currency in which the transaction should be made. View the list of supported currencies. The length must be 3 characters.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
string
Your receipt id for this order should be passed here. Maximum length is 40 characters.
boolean
Indicates whether the customer can make a partial payment. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
object
required
Details about the customer/user.
string
required
The customer’s name. For example, Gaurav Kumar.
string
required
The customer’s phone number. A maximum length of 15 characters, including country code. For example, +919000090000.
string
required
The customer’s email address. For example, gaurav.kumar@example.com.
object
Additional details of the customer, including past transaction data.
integer
Total orders placed by the account so far on the merchant platform. For example, 22.
integer
Total chargeback received for the customer account on the merchant platform. For example, 4.
string
Your company’s passenger classification, such as with a frequent flyer program. In this case, you might use values such as:
  • standard
  • gold
  • platinum
string
To share if the user is an agent, corporate, or individual. Possible values:
  • agent
  • corporate
  • individual
boolean
To denote if the buyer is on guest checkout or has logged into the account. Possible values:
  • true: If the user is logged into the account.
  • false: If the user is on guest checkout.
integer
UNIX timestamp when the customer account was created with the merchant. For example, 1234567890.
object
required
This will have details about the billing address of the customer/user.
string
required
Address Line 1 of the address.
string
required
Address Line 2 of the address.
string
required
City of the address. For example, Bengaluru.
string
required
ISO3 country code of the billing address. For example, IND.
string
required
Name of the state. For example, KA.
string
required
Zipcode of the state. For example, 560001.
float
required
Latitude of the position expressed in decimal degrees (WSG 84), for example, 6.244203. A positive value denotes the northern hemisphere or the equator, and a negative value denotes the southern hemisphere. The number of digits represents the precision of the coordinate.
float
required
Longitude of the position expressed in decimal degrees (WSG 84), for example, -75.581211. A positive value denotes east longitude or the prime meridian, and a negative value denotes west longitude. The number of digits represents the precision of the coordinate.
integer
Total sum of the cart value.
object
required
Details about the specific items added to the cart.
string
required
Defines the category type. Possible values:
  • travel
  • hotel
  • e_commerce
  • digital_services
  • mutual_fund
string
required
unique product id defined by the business.
string
The name of the product.
string
Description of the product.
integer
required
Number of tickets/items/quantity to be purchased.
string
URL of the product image.
string
URL of the product’s listing page.
integer
required
Unit price of the product in paisa. (needs to be inclusive of tax)
integer
Offer price of the product. The offer price can be lower than the price if the business is running any discount on the product.
integer
Tax amount that needs to be added to the product. In case the offer_price is tax-inclusive, keep it blank.
object
Details about the type-specific data points. Will vary based on the type selected.
string
The sub-type of the line item. Possible values:
  • stay
  • breakfast
  • dinner
  • lunch
  • early_checkin
  • late_chechout
  • others
string
Represents an ISO 8601-encoded date string. For example, September 7, 2019 is represented as 2019-07-16.
string
Represents an ISO 8601-encoded date string. For example, September 7, 2019 is represented as 2019-07-16.
string
Represents the type of the property. Possible values:
  • resort
  • hostel
  • hotel
  • inn
  • lodge
  • motel
  • apartment
  • bed_and_breakfast
  • tent
  • villa
integer
Denotes the star rating of the property. Possible values: 1 to 7.
string
Brand name of the property. For example, Marriott Group.
object
Details of the property address.
string
Address Line 1 of the address.
string
Address Line 2 of the address.
string
city of the address. For example, Bengaluru.
string
ISO3 country code of the billing address. For example, IND.
string
Name of the state. For example, KA.
string
Zipcode of the state. For example, 560001.
float
Latitude of the position expressed in decimal degrees (WSG 84), for example, 6.244203. A positive value denotes the northern hemisphere or the equator, and a negative value denotes the southern hemisphere. The number of digits represents the precision of the coordinate.
float
Longitude of the position expressed in decimal degrees (WSG 84), for example, -75.581211. A positive value denotes east longitude or the prime meridian, and a negative value denotes west longitude. The number of digits represents the precision of the coordinate.
object
Details associated with passengers/travellers/beneficiaries.
string
Name of the passenger/traveler/beneficiary.
string
Email address of the passenger/traveler/beneficiary.
object
Details associated with passengers/travelers/beneficiaries.
integer
UNIX timestamp of the date of birth of the individual. For example, 1234567890.
string
Type of the flight ticket. Possible values:
  • Business
  • Suite
  • Premium
  • Deluxe
  • Standard
object
Identity details of the passenger/beneficiary.
string
National ID number. For example, Adhaar number for India.
string
Passport number of the individual.
array
Payment capture settings for the payment. The options sent here override the account level auto-capture settings configured using the Dashboard.
string
required
Option to automatically capture payment. Possible values:
  • automatic: Payments are auto-captured according to the configurations specified in the capture_options array.
  • manual: You have to manually capture payments using our Capture API or from the Dashboard.
array
Use this array to determine the expiry period for automatic and manual capture of payments and the refund speed in the case of non-capture.
integer
Time in minutes till when payments in the authorized state should be auto-captured. Minimum value 12 minutes. This parameter is mandatory only if the value of capture parameter is automatic.
integer
Time in minutes till when you can manually capture payments in the authorized state.
  • Must be equal to or greater than the automatic_expiry_period value.
  • Default value 7200 minutes.
  • Maximum value 7200 minutes.
  • Payments in the authorized state after the manual_expiry_period are auto-refunded.
string
required
Refund speed for payments that were not captured (automatically or manually). Possible values:
  • optimum: We try to process the refund instantly. We charge a small fee for this. If it is not possible to process an instant refund, we will process a normal refund in 5-7 working days. Learn more about instant refunds.
  • normal: The refund is processed in 5-7 working days.

    If no value is passed, the refund is processed using the default speed set on the Dashboard.
string
Denotes if the cart items are refundable or not. Possible values:
  • full
  • partial
  • not_allowed
object
Details of the campaign. *Can be extended to share UTM parameters.
string
Unique identifier of the campaign. For example, PQR12453.
string
Name of the campaign.
string
A human-readable description of the campaign.
string
The marketing channel used.
string
The referrer of the marketing event. Example values: google, newsletter.
string
The medium that the campaign is using. Example values: cpc, banner, etc.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
integer
The transaction amount, expressed in the currency subunit. For example, for an actual amount of ₹299.35, the value of this field should be 29935.
integer
The amount pending against the order.
integer
The amount paid against the order.
integer
The number of payment attempts, successful and failed, that have been made against this order.
integer
The UNIX timestamp at which the order is created.
string
The currency in which the transaction should be made. View the list of supported currencies. Length must be of 3 characters.
string
Name of the entity. Here, it is order.
string
The unique identifier of the order.
object
Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
string
The unique identifier of the offer.
string
Your receipt id for this order should be passed here. Maximum length is 40 characters.
string
The status of the order. Possible values:
  • created: When you create an order, it is in the created state. It stays in this state till a payment is attempted on it.
  • attempted: An order moves from created to attempted state when a payment is first attempted on it. It remains in the attempted state till one payment associated with that order is captured.
  • paid: After the successful capture of the payment, the order moves to the paid state. No further payment requests are permitted once the order moves to the paid state. The order stays in the paid state even if the payment associated with the order is refunded.
The error response parameters are available in the API Reference Guide.
Once the order is created, pass the order_id from the Orders API response to the Payments API.POST /payments/create/json
integer
required
Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Watch Out!As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to charge a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as 99990 and not 99991.
string
required
Currency code for the currency in which you want to accept the payment. For example, INR. Refer to the list of supported currencies. The length must be 3 characters.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
string
required
Unique identifier of the Order.
string
required
Email address of the customer. The maximum length supported is 40 characters.
string
required
Phone number of the customer. The maximum length supported is 15 characters, inclusive of country code.
string
required
Name of the payment method. Possible value is card.
object
required
Details associated with the card.
string
Unformatted card number.
string
Name of the cardholder.
string
Expiry month for the card in MM format.
string
Expiry year for the card in YY format.
string
CVV printed on the back of the card.
Handy Tips
  • CVV is not required by default for tokenised cards across all networks.
  • CVV is optional for tokenised card payments. Do not pass dummy CVV values.
  • To implement this change, skip passing the cvv parameter entirely, or pass a null or empty value in the CVV field.
  • We recommend removing the CVV field from your checkout UI/UX for tokenised cards.
  • If CVV is still collected for tokenised cards and the customer enters a CVV, pass the entered CVV value to Razorpay.
string
required
The User-Agent header of the user’s browser. The default value will be passed by Razorpay if not provided by you.
string
required
The customer’s IP address.
object
Details of the authentication channel.
string
The authentication channel for the payment. Possible values:
  • browser (default)
  • app
object
required
Information regarding the customer’s browser. This parameter need not be passed when authentication_channel=app.
boolean
Indicates whether the customer’s browser supports Java. Obtained from the navigator HTML DOM object. Possible values:
  • true: Customer’s browser supports Java.
  • false: Customer’s browser does not support Java.
boolean
Indicates whether the customer’s browser can execute JavaScript. Obtained from the navigator HTML DOM object. Possible values:
  • true: Customer’s browser can execute JavaScript.
  • false: Customer’s browser cannot execute JavaScript.
integer
Time difference between UTC time and the cardholder’s browser local time. Obtained from the getTimezoneOffset() method applied to the Date object.
integer
Total width of the payer’s screen in pixels. Obtained from the screen.width HTML DOM property.
integer
Obtained from the navigator HTML DOM object.
integer
Obtained from the payer’s browser using the screen.colorDepth HTML DOM property.
string
Obtained from the payer’s browser using the navigator.language HTML DOM property. Maximum limit of 8 characters.
object
Key-value object used for passing tracking info. Refer to Notes for more details.
string
URL endpoint where Razorpay will submit the final payment status.
string
Referrer header passed by the client’s browser.
array
A list of action objects available to continue the payment process. Present when the payment requires further processing.
string
Indicates the next step to continue the payment process. Possible values:
  • otp_generate: Use this URL to allow the customer to generate OTP and complete the payment on your webpage.
  • redirect: Use this URL to redirect the customer to submit the OTP on the bank page.
string
URL to be used for the action indicated.
string
Unique identifier of the payment. Present for all responses.
The error response parameters are available in the API Reference Guide.

1.3 Handle Payment Success and Error Events

Once the payment is completed by the customer, a POST request is made to the callback_url provided in the payment request. The data contained in this request will depend on whether the payment was a success or a failure.

Success Callback

If the payment made by the customer is successful, the following fields are sent:
  • razorpay_payment_id
  • razorpay_order_id
  • razorpay_signature
Callback Example

Failure Callback

If the payment has failed, the callback will contain details of the error. Refer to Errors for details.

1.4 Verify Payment Signature

Signature verification is a mandatory step to ensure that the callback is sent by Razorpay. The razorpay_signature contained in the callback can be regenerated by your system and verified as follows. Create a string to be hashed using the razorpay_payment_id contained in the callback and the Order ID generated in the first step, separated by a |. Hash this string using SHA256 and your API Secret.

Generate Signature on your Server

1.5 Integrate Payments Rainy Day Kit

Use Payments Rainy Day kit to overcome payments exceptions such as:

1.6 Verify Payment Status

Handy TipsOn the Razorpay Dashboard, ensure that the payment status is captured. Refer to the payment capture settings page to know how to capture payments automatically.
To verify the payment status from the Razorpay Dashboard:
  1. Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
  2. Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
Payment details on Dashboard

Next Steps

Proceed to testing your International Cards integration.
Last modified on November 20, 2026